//Problem G of ACM ICPC, Tehran Region, December 2008
//Author: Saeed Seddighin
//From team: AnacondaTigers of SUT
#include <cstdio>
#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

const int MAX_N=1000+20,INF=1<<25;

typedef pair<int,int> Pair;

int n,ans[2][MAX_N][MAX_N],len,t;
vector<Pair> num[MAX_N];
vector<int> dyna[MAX_N],dyna2[MAX_N];

inline bool Read(){
  cin>>len>>t;
  if (len ==0 && t==0) return(false);
  vector<int> y,x1,x2;
  for (int i=1;i<=len;i++){
    int Y,X1,X2;
    cin>>Y>>X1>>X2;

    if (X1 > X2) swap(X1,X2);

    y.push_back(Y);
    x1.push_back(X1);
    x2.push_back(X2);
  }
  map<int,int> Map;
  for (int i=0;i<y.size();i++) Map[y[i]]=0;
  n=1;
  for (map<int,int> :: iterator i=Map.begin();i!=Map.end();i++,n++) i->second=n;
  n--;

  for (int i=0;i<y.size();i++) y[i]=Map[y[i]];

  for (int i=1;i<=n;i++) num[i].clear();
  for (int i=0;i<y.size();i++) num[y[i]].push_back(Pair(x2[i],x2[i]-x1[i]));

  for (int i=1;i<=n;i++) sort(num[i].begin(),num[i].end());
  return(true);
}

inline void make(int s){
  dyna[s].clear();
  dyna[s].resize(num[s].size()+1);
  dyna2[s].clear();
  dyna2[s].resize(num[s].size()+1);

  for (int i=1;i<dyna[s].size();i++) dyna[s][i]=INF;
  for (int i=1;i<dyna2[s].size();i++) dyna2[s][i]=INF;

  multiset<int> Set;

  for (int i=0;i<num[s].size();i++){
    Set.insert(num[s][i].second);
    int count=1,sum=num[s][i].first*2;
    for (multiset<int> :: iterator i=Set.begin();i!=Set.end();i++,count++){
      sum+=*i;
      dyna[s][count]=min(dyna[s][count],sum);
    }
    count=1;
    sum=num[s][i].first;
    for (multiset<int> :: iterator i=Set.begin();i!=Set.end();i++,count++){
      sum+=*i;
      dyna2[s][count]=min(dyna2[s][count],sum);
    }
  }
}

int main(){
  while (Read()){
    for (int i=1;i<=n;i++) make(i);

//     for (int i=1;i<=n;i++,cout<<endl) for (int j=0;j<dyna[i].size();j++) cout<<dyna[i][j]<<' ';    
    

//     cout<<endl;
    for (int a=0;a<=1;a++) for (int i=0;i<=n;i++) for (int j=0;j<=len;j++) ans[a][i][j]=INF;
    ans[0][0][0]=ans[1][0][0]=0;

    for (int i=1;i<=n;i++) for (int j=0;j<=len;j++) for (int a=0;a<dyna[i].size() && a <=j ;a++){
       ans[0][i][j]=min(ans[0][i][j],ans[0][i-1][j-a]+dyna[i][a]);
       if (a) ans[1][i][j]=min(ans[1][i][j],ans[0][i-1][j-a]+dyna2[i][a]);
       else ans[1][i][j]=min(ans[1][i][j],ans[1][i-1][j]);
    }

    int Max=0;
    while (Max < len && ans[1][n][Max+1] <= t) Max++;
    cout<<Max<<endl;
						      
  }
}
