//Problem B of ACM ICPC, Tehran Region, December 2008
//Author: Aideen NasiriShargh
//From team: AnacondaTigers of SUT
#define D 0
#include <iostream>
#include <vector>
#define FOR(i,x,n) for(__typeof(x) i = (x); i != (n); i++)
#define FR(i,n) FOR(i,0,n)
#define CLR(a,v) memset(a, v, sizeof a);
#define R 0
#define C 1
#define PB push_back
#define SZ size()
#define show(x) cerr << #x << " = " << x << endl;
#define count eye_count
using namespace std;

const int MAX_N = 100 + 2;
bool isPainted[2][MAX_N];

int n, m;
int a[MAX_N][MAX_N];
int count[100*1000];

vector<int> ans;

int canBePainted(int rc, int ind) {
  int can = -1, nz = 0;
  if (rc == R) {
    FR(j,m) if (a[ind][j] != -1) {
      nz++;
      if (can == -1) can = a[ind][j];
      else if (can != a[ind][j]) return -1;
    }
  }
  else {
    FR(i,n) if (a[i][ind] != -1) {
      nz++;
      if (can == -1) can = a[i][ind];
      else if (can != a[i][ind]) return -1;
    }
  }
  if (can != 0) {
    if (nz != count[can]) return -1;
  }

  return can;
}

void PrintAndClear(int rc, int ind) {
  if (D) cerr << "-------> P & C: " << rc << " " << ind << endl;
  isPainted[rc][ind] = true;
  if (rc == R) 
    FR(j,m) {count[a[ind][j]]--; a[ind][j] = -1; }
  else 
    FR(i,n) {count[a[i][ind]]--; a[i][ind] = -1; }
}

void showMat() {
  FR(i,n) {
    FR(j,n) cerr << a[i][j] << " ";
    cerr << endl;
  }
}

int main() {
  while (cin >> n >> m && n && m) {
    CLR(isPainted, false);
    ans.clear();
    CLR(count, 0);
    FR(i,n) FR(j,m) { cin >> a[i][j]; count[a[i][j]]++; }

    int w;
    while(true) {
      if (D) showMat();

      int bestr = -1, bestrc = -1;
      FR(i,n) 
        if (!isPainted[R][i] && (w = canBePainted(R, i)))
          if ((w != -1) && (bestr == -1 || w > bestrc)) {
            bestr = i;
            bestrc = w;
          }

      int bestc = -1, bestcc = -1;
      FR(j,m) 
        if (!isPainted[C][j] && (w = canBePainted(C, j)))
          if ((w != -1) && (bestc == -1 || w > bestcc)) {
            bestc = j;
            bestcc = w;
          }

      if (bestc == -1 && bestr == -1) break;
      if (D) {
	show(bestr);
	show(bestc);
      }

      if (bestc == -1 || (bestr != -1 && bestcc > bestrc)) {
        PrintAndClear(R, bestr);
	ans.PB(bestrc);
      }
      else { 
        PrintAndClear(C, bestc);
	ans.PB(bestcc);
      }
    }
    int k = ans.SZ;
    reverse(ans.begin(), ans.end());
    FR(i,k) {
      cout << ans[i];
      cout <<  ((i == k-1) ? "\n" : " ");
    }
  }
  return 0;
}
