//Problem C of ACM ICPC, Tehran Region, December 2008
//Author: Saeed Seddighin
//From team: AnacondaTigers of SUT
#include <cstdio>
#include <iostream>

using namespace std;

typedef pair<int,int> Pair;

const int MAX_N=100+20;

int n,m,next[MAX_N][MAX_N],prev[MAX_N][MAX_N];
char in[MAX_N][MAX_N];
int dyna[MAX_N][MAX_N][MAX_N];
Pair num[MAX_N][MAX_N];

int main(){
  while (cin>>n>>m){
    if (n==0 && m==0) break;
    for (int i=1;i<=n;i++) for (int j=1;j<=m;j++) for (int k=1;k<=m;k++) dyna[i][j][k]=0;

    for (int i=1;i<=n;i++) for (int j=1;j<=m;j++) cin>>in[i][j];

    for (int i=0;i<=n+1;i++) for (int j=0;j<=m+1;j++) num[i][j]=Pair(j,j);

    for (int i=1;i<=n;i++){
      int point=1;
      while (point <= m){
	if (in[i][point] == '0'){
	  num[i][point].first=num[i][point].second=point;
	  point++;
	}else{
	  int temp=in[i][point]-'0';
	  for (int j=1;j<=temp;j++){
	    num[i][j+point-1].first=point;
	    num[i][j+point-1].second=point+temp-1;
	  }
	  point+=temp;
	}
      }
    }

//     for (int i=1;i<=n;i++,cout<<endl) for (int j=1;j<=m;j++) cout<<'('<<num[i][j].first<<','<<num[i][j].second<<')';

    for (int i=1;i<=n;i++)
      for (int j=1;j<=m;j++){
	next[i][j]=j;
	while (next[i][j] < m && in[i][next[i][j]+1] == '0') next[i][j]++;
	prev[i][j]=j;
	while (prev[i][j] > 1 && in[i][prev[i][j]-1] == '0') prev[i][j]--;
      }

    for (int i=1;i<=n;i++) for (int j=1;j<=m;j++){
	int sum=0;
	for (int k=j;k<=m;k++){
	  if (num[i][k].first >= j && num[i][k].second == k) sum+=in[i][k]-'0';
	  dyna[i][j][k]=sum+dyna[i-1][num[i-1][prev[i][j]-1].second+1]
	                             [num[i-1][next[i][k]+1].first -1];
	}
    }

//     for (int i=1;i<=n;i++) for (int j=1;j<=m;j++) for (int k=j;k<=m;k++) cout<<i<<' '<<j<<' '<<k<<' '<<dyna[i][j][k]<<endl;

    int ans=0;
    for (int i=1;i<=n;i++)
      for (int j=1;j<=m;j++)
	if (in[i][j]!='0')
	  ans=max(ans,dyna[i][num[i][j].first][num[i][j].second]);
    cout<<ans<<endl;
  }
}
