//Problem D of ACM ICPC, Tehran Region, December 2008
//Author: Nima Ahmadi Pour Anari
//From team: AnacondaTigers of SUT
#include <iostream>
#include <iomanip>
#include <complex>
#define X real()
#define Y imag()
using namespace std;
int n;
typedef complex<double> point;
point p[100];
double cross(const point& a,const point& b){
	return a.X*b.Y-a.Y*b.X;
}
int main(){
	int tnum=0;
	cout<<fixed<<setprecision(6);
	while (cin>>n,n){
		for (int i=0;i<n;++i){
			double x,y;cin>>x>>y;
			p[i]=point(x,y);
		}
		double area=0;
		point s(0,0);
		for (int i=0;i<n;++i){
			double carea=cross(p[i],p[(i+1)%n]);
			point q=(p[i]+p[(i+1)%n])/3.0;
			s+=carea*q;
			area+=carea;
		}
		s/=area;
		cout<<"Stage #"<<++tnum<<": ";
		cout<<s.X<<' '<<s.Y<<endl;
	}
	return 0;
}
